#Initialization and front calcualtions
import random               #imports random
import numpy as np
from math import *
import matplotlib.pyplot as plt #imports graphing feature
shots=1000                  #the number of shots we will take (more = better accuracy)
xmaxF=4.0                   #sets the maximum y value
x2=[]                       #blank list to hold x values for the graph
y2=[]                       #blank list to hold y values for the graph
n=0.0                       #initialize counting variable

#these lines are specific to the y=x^2 function
def funct(x): return x**2       #defines a function to return the value of our function. 
intfx=(1.0/3.0)*xmaxF**3      #mathematically calculates the integral using calculus (integral of y=x^2 is 1/3*x^3)
#END of function specific lines

fXmax = funct(xmaxF)               #calculate the maximum y value as f(xmax)
Atot = xmaxF*fXmax               #the area of the square 

# Run the MonteCarlo shots----------------------------------------
for i in range(1,shots):
    x=random.random()*xmaxF     #randomly picks an x value between zero and xmax
    y=random.random()*fXmax    #randomly picks an x value between zero and F(xmax)    
    x2.append(x)               #appends current value of x to list of x values
    y2.append(y)               #appends current value of y to list of y values
    if y < funct(x) :          #if random value of y is less that f(x) increment counter by one
        n=n+1
# end of montecarlo shots----------------------------------------------
        
frac = n/(i+1)               #this is the fraction of shots that landed in the shaded area

#Create the Graph
x = np.linspace(0, 4.0)   #gives the x values for the graph
y = funct(x)                  #the function to graph
plt.fill_between(x, y, y2=0, facecolor='cyan', alpha=0.2) #shades the area under the function (alpha sets opacity
plt.plot(x2,y2, 'r+')   #plots the points ro=red circles
plt.grid(True)          #turns on grid
plt.show()              #shows graph
print 'result of test=', frac*Atot  #prints the calculated area 
print 'integral of f(x) =', intfx #prints mathematical area 
