# runs MonteCarlo integration on a circle to find pi
# y = sqrt(R^2-x^2)
#----------------------------------------------
# import pieces and setup subroutines 
import random
from math import *
def avg(s): return sum(s)*1.0/len(s) 				#define a function to average the values
from ShawnFunctions import stddev  					# a file i've created that has a standard deviations functions (stddev)
# Program Start--------------------------------------------------
intavg=0.0
results = []
values = []			#to store the values in
iterations = 1000	# number of time to run the experiment 
shots=100			# number of shots to take in the area
xmax=1	        	# radius of the circle is 1.0
ymax=1	            # ymax is also the radius
for o in range(0,iterations):
	n=0.0
	for i in range(1,shots+1) :
		x=random.random()*xmax
		y=random.random()*ymax
		fx=sqrt(1-x**2)
		if y < fx :
			n=n+1
        values.append(4.0*n/i)
	results.append(avg(values))
ResultsAvg = avg(results)
StandardDeviation=stddev(results)
print 'average of ',iterations,'iterations to find pi = ', ResultsAvg
print 'standard devation of iterations =',StandardDeviation
print 'standard error in the mean=',StandardDeviation/sqrt(len(results))
print 'accepted value of pi =', pi

#---------write data to csv to read later--------------
f=open('pi.dat','w+')
for a in results:
	f.write('%f\n'%a)
#f.write('\n')
f.close()